#!/usr/bin/perl
use strict;
use warnings;

my $infile  = "infile.txt";
my $outfile = "outfile.txt";

open(INFILE,"$infile") or die "$!";
my @inFileCont = <INFILE>;
close INFILE;

my ($tempSecRecs) = &fasReader2D(\@inFileCont);
my @recs = @$tempSecRecs;

open(OUT, ">$outfile");
foreach my $ele (@recs){
  my $name = $ele->[0];
  print OUT "$name\n";
  my $sequence = join('',@{$ele->[1]});
  my $revcomp = revCom($sequence);
  print OUT "$revcomp\n";
}
close OUT;

exit;

sub revCom {
  my ($seqLine) = @_; 
  my $revcomp = reverse($seqLine);
  $revcomp =~ tr/ATGCatgc
                /TACGtacg/;
  $revcomp =~ tr/atgc/ATGC/;
  return ($revcomp);
}

sub fasReader2D{

  my $uniqNameSR = "";
  my $tempLines = "";
  my @tempLinesCont = ();
  my @records   = ();
  my $flag = 0;

  my ($inFileContSR) = @_;

  foreach my $inFileLine (@$inFileContSR) {
    chomp($inFileLine);
    next if $inFileLine =~ /^$/;
    if($inFileLine =~ /^[>|<]/){  
      if($flag == 0){
        $uniqNameSR = $inFileLine;
        $flag = 1;  
      } else {
        my @tmp = @tempLinesCont;
        push(@records, [$uniqNameSR, \@tmp]);
        $uniqNameSR = "$inFileLine";
        @tempLinesCont = ();
      }
    } else {
      push(@tempLinesCont, $inFileLine);
    }
  }
  my @tmp = @tempLinesCont;
  push(@records, [$uniqNameSR, \@tmp]);

  return (\@records);

}
